* BROWSEFN.PRG

* This function allows the edit of a database based on defined arrays and vars

*    be_disp[]  = display fields (actual fields or expressions)
*    be_dpict[] = display pictures
*    be_colhd[] = browse column headings
*    be_get[]   = get field list
*    be_desc[]  = edit field descriptions
*    be_epict[] = get pictures
*    be_valid[] = get valid clauses
*    be_help[]  = field help memos
*    be_newfn   = function called when insert or append is requested
*    be_delfn   = function called when delete is requested
*    be_edfn    = function called to get fields
*    be_header  = browse mode header
*    be_footer  = browse mode footer
*    be_packimm = pack immediately on delete?
*    be_statlin = show status line?
*    be_verify  = verify delete records?
*    be_getct   = count of get fields (dummies included)
*    be_dispct  = count of browse display fields

FUNCTION BEDIT
     PARAMETER dctfile
     PRIVATE i,toprec,botrec
     PUSHS()

     IF TYPE("dctfile")="C"
        IF LEN(dctfile)>0
           DO STDHEAD  && get something on the screen, temporarily
           RESTORE FROM (dctfile) ADDITIVE
           DECLARE be_disp[50]
           DECLARE be_dpict[50]
           DECLARE be_colhd[50]
           DECLARE be_get[50]
           DECLARE be_desc[50]
           DECLARE be_epict[50]
           DECLARE be_valid[50]
           DECLARE be_help[50]
           QPARSE(be_disp,be__disp)
           QPARSE(be_dpict,be__dpict)
           QPARSE(be_colhd,be__colhd)
           be_getct=QPARSE(be_get,be__get)
           QPARSE(be_desc,be__desc)
           QPARSE(be_epict,be__epict)
           QPARSE(be_valid,be__valid)
           QPARSE(be_help,be__help)
        ENDIF
     ENDIF

     toprec = 0
     botrec = 0
     desclen = 0
     delflag = .f.
     markln=0
     CLEAR
     IF LEN(be_header)>0
        FOR i=1 TO 5
            @ i-1,0 SAY MEMOLINE(be_header,78,i)
        NEXT
     ELSE
        DO STDHEAD
     ENDIF
     IF LEN(be_footer)>0
        FOR i=1 TO 5
            @ i+18,0 SAY MEMOLINE(be_footer,78,i)
        NEXT
     ELSE
        DO STDFOOT
     ENDIF
     FOR i = 1 TO be_getct
         IF desclen<LEN(be_desc[i])
            desclen = LEN(be_desc[i])
         ENDIF
     NEXT
     WHEREAMI()
     @ 5,0,18,79 BOX ""
     DBEDIT(4,1,18,78,be_disp,"be_fn",be_dpict,be_colhd,"","","")
     IF .not. be_packimm
        IF delflag
           @ 10,30 CLEAR TO 12,60
           @ 10,30 TO 12,60 DOUBLE
           @ 11,32 SAY "PACKING...  Please wait."
           PACK
        ENDIF
     ENDIF
     POPS()
RETURN .T.

FUNCTION BE_FN
     PARAMETERS be_status, be_fld
     PRIVATE be_request,be_key,oldrec,ans
     be_key = LASTKEY()
     be_request = 1
     be_ed = .t.
     DO CASE
        CASE be_status = 0          && IDLE
             IF be_statlin
                @ 0,40
                @ 0,40 SAY "Record " + LTRIM(STR(RECNO(),6,0)) + " "
                @ 0,55 SAY IF (DELETED(),"<deleted>","         ")
                IF toprec = botrec
                   @ 65,0 SAY "<Top/End file>"
                ELSE
                   IF RECNO() = toprec
                      @ 65,0 SAY "<Top of file>"
                   ENDIF
                   IF RECNO() = botrec
                      @ 65,0 SAY "<End of file>"
                   ENDIF
                ENDIF
             ENDIF
        CASE be_status = 1          && BOF
        CASE be_status = 2          && EOF
        CASE be_status = 3          && EMPTY
        CASE be_status = 4          && KEYSTROKE EXCEPTION
             be_key = UPPER(CHR(be_key))
             DO CASE
                CASE be_key = "A"      && APPEND
                     IF LEN(be_newfn)>0
                        APPEND BLANK
                        DO &be_newfn
                     ELSE
                        APPEND BLANK
                     ENDIF
                     DO BFLDED WITH "APPEND RECORD:"
                     be_request = 2
                     WHEREAMI()
                CASE be_key = "C" .or. be_key = CHR(13) && CHANGE
                     DO MARKLN
                     DO BFLDED WITH "CHANGE RECORD:"
                     DO UNMARKLN
                     be_request = 2
                     WHEREAMI()
                CASE be_key = "D" .or. be_key=CHR(7)    && DELETE
                     ans="Y"
                     IF be_verify
                        DO MARKLN
                        SET CURSOR ON
                        @ 24,0 SAY "Are you sure you want to delete this record?"
                        ?? CHR(7)
                        ans=UPPER(CHR(INKEY(0)))
                        @ 24,0
                        SET CURSOR OFF
                        DO UNMARKLN
                     ENDIF
                     IF ans="Y"
                        IF LEN(be_delfn)>0
                           DO &be_delfn
                        ELSE
                           IF be_packimm
                              oldrec=RECNO()
                              DELETE
                              PACK
                              GO oldrec
                              IF EOF()
                                 GO BOTTOM
                              ENDIF
                           ELSE
                              IF DELETED()
                                 RECALL
                              ELSE
                                 DELETE
                                 delflag=.t.
                              ENDIF
                           ENDIF
                        ENDIF
                     ENDIF
                     be_request = 2
                     WHEREAMI()
                CASE be_key = "I" .or. be_key=CHR(22)   && INSERT
                     IF LEN(INDEXKEY(1)) = 0
                        DO INSBLANK
                        @ 24,0
                     ELSE
                        DO MARKLN
                        APPEND BLANK
                     ENDIF
                     IF LEN(be_newfn)>0
                        DO &be_newfn
                     ENDIF
                     DO BFLDED WITH "INSERT RECORD:"
                     DO UNMARKLN
                     be_request = 2
                     WHEREAMI()
                CASE be_key = "P"      && PRINT
                     DO BEPRINT
                     be_request = 2
                CASE be_key = "S"      && SEARCH
                     DO BESEARCH
                     be_request = 2
                CASE be_key = "V"      && VIEW
                     be_ed = .f.
                     DO MARKLN
                     DO BFLDED WITH "VIEW RECORD:"
                     DO UNMARKLN
                     be_ed = .t.
                CASE be_key = "E" .or. be_key = CHR(27)  && QUIT
                     be_request = 0
             ENDCASE
     ENDCASE
RETURN be_request

PROCEDURE STDHEAD
     @ 2,0 SAY "Browsing file: " + ALIAS()
RETURN

PROCEDURE STDFOOT
     @ 20, 0 SAY "Use the cursor keys to select a record and/or or use one of the following:"
     @ 22, 4 SAY "Append   Change   Delete   Insert   Print   Search   View   Exit"
RETURN

PROCEDURE BFLDED
     PARAMETER msg
     PRIVATE fldct,i,j,max_per_pg,pg_beg,getfld,getpct,getvld,pages,_fld
     PUSHS()
     SET CURSOR ON
     IF LEN(be_edfn)>0
        DO &be_edfn
     ELSE
        * loop through pages
        max_per_pg = 20
        IF be_getct<max_per_pg
           max_per_pg=be_getct
        ENDIF
        pages = INT ( ( be_getct - 1 ) / max_per_pg ) + 1
        FOR i = 1 TO pages
            @ 3,15 CLEAR TO max_per_pg+4,71
            @ 3,15 TO max_per_pg+4,71 DOUBLE
            @ 3,16 SAY msg
            IF pages>1
               @ 3,53 SAY "Pg " + LTRIM(STR(i,3,0)) + " of " + LTRIM(STR(pages,3,0))
            ENDIF
            * loop through gets on this page
            pg_beg = (i - 1) * max_per_pg + 1
            _fld = pg_beg
            j = 1
            DO WHILE _fld <= be_getct .and. j<=max_per_pg
               getfld = be_get[_fld]
               getpct = be_epict[_fld]
               IF getfld<>"."
                  IF LEN(be_valid[_fld])>0
                     @ j + 3,17           SAY     be_desc[_fld]
                     @ j + 3,desclen + 19 GET     &getfld;
                                          PICTURE getpct;
                                          VALID   BEVALID()
                  ELSE
                     @ j + 3,17           SAY     be_desc[_fld]
                     @ j + 3,desclen + 19 GET     &getfld;
                                          PICTURE getpct
                  ENDIF
               ENDIF
               _fld = _fld + 1
               J = J + 1
            ENDDO
            IF be_ed
               READ
            ELSE
               INKEY(0)
               CLEAR GETS
            ENDIF
            IF LASTKEY() = 18
               IF i>1
                  i = i - 2
               ELSE
                  i = i - 1
               ENDIF
            ENDIF
            IF LASTKEY() = 27
               i = 99
            ENDIF
        NEXT
     ENDIF
     SET CURSOR OFF
     POPS()
RETURN

FUNCTION WHEREAMI
     oldrec = RECNO()
     GO TOP
     toprec = RECNO()
     GO BOTTOM
     botrec = RECNO()
     GO oldrec
RETURN .T.

FUNCTION BEVALID
     PRIVATE var,varpos,result,vld
     result = .t.
     var = READVAR()
     varpos = ASCAN(be_get,var)
     IF varpos>0
        vld = be_valid[varpos]
        result = &vld
     ENDIF
RETURN result

PROCEDURE INSBLANK
     PRIVATE _oldrec,_eofstat,_i,_j,_fld
     _oldrec = RECNO()          && save current record position
     _eofstat = EOF()           && save current EOF status
     @ 24,0
     @ 24,0 SAY "Inserting. . ."
     APPEND BLANK               && append a blank record
     IF _eofstat                && if we were already at end of file,
        RETURN                  &&  there's nothing else to do,
     ENDIF                      && so return
     FOR _i = 1 TO FCOUNT()     && loop through fields to define field vars
         _fld = FIELDNAME(_i)
         PRIVATE &_fld
     NEXT
     FOR _i = LASTREC() - 1 TO _oldrec STEP -1
         GO _i                  && get record to move
         DO DBF2MEM
         GO _i + 1
         DO MEM2DBF
         IF INKEY() = 27
            GO _i
            DELETE
            @ 24,0
            @ 24,0 SAY "Insert operation interrupted.  Packing . . ."
            PACK
            GO BOTTOM
            SKIP                && set EOF to flag that edit can't continue
            _i = -2
         ENDIF
     NEXT
     IF ! EOF()                 && check to see if operator pressed ESC
        GO _oldrec
        DO BLANK2DBF            && blank the current record
     ENDIF
RETURN

PROCEDURE DBF2MEM
     PRIVATE _i,_fld
     FOR _i=1 TO FCOUNT()
         _fld=FIELDNAME(_i)
         &_fld=&_fld
     NEXT
RETURN

PROCEDURE MEM2DBF
     PRIVATE _i,_fld
     FOR _i=1 TO FCOUNT()
         _fld=FIELDNAME(_i)
         REPLACE &_fld WITH m->&_fld
     NEXT
RETURN

PROCEDURE BLANK2DBF
     PRIVATE _i,_fld
     FOR _i=1 TO FCOUNT()
         _fld=FIELDNAME(_i)
         DO CASE
            CASE TYPE(_fld)="C"
                 REPLACE &_fld WITH ""
            CASE TYPE(_fld)="D"
                 REPLACE &_fld WITH CTOD("  /  /  ")
            CASE TYPE(_fld)="N"
                 REPLACE &_fld WITH 0
            CASE TYPE(_fld)="L"
                 REPLACE &_fld WITH .f.
            CASE TYPE(_fld)="M"
                 REPLACE &_fld WITH ""
         ENDCASE
     NEXT
RETURN

PROCEDURE BEPRINT
     PRIVATE i, ct, _array[FCOUNT()],_disp[FCOUNT()],_hdr[FCOUNT()]
     PRIVATE _dispstr,ans,oldrec,_fld,pg,_hdrprt,_opcol,_graphics
     PUSHS()
     @ 2,20 CLEAR TO 22,78
     @ 2,20 TO 22,78 DOUBLE
     @ 2,22 SAY "PRINT"
     @ 4,22 SAY "Do you want column headers? "
     _hdrprt=(UPPER(CHR(INKEY(0)))="Y")
     IF LASTKEY()=27
        RETURN
     ENDIF
     @ 4,22 SAY "Use column seperation lines?"
     _graphics=(UPPER(CHR(INKEY(0)))="Y")
     IF LASTKEY()=27
        RETURN
     ENDIF
     @ 21,22 SAY "Columns used: "
     @  4,22 SAY "Select fields for printing: "
     ct=SELFLDS()
     IF ct>0
        @ 2,20 CLEAR TO 22,78
        @ 2,20 TO 22,78 DOUBLE
        @ 2,22 SAY "PRINT"
        @ 6,22 SAY "Press RETURN to begin printing, or ESC to quit."
        ans=0
        DO WHILE ans<>13 .and. ans<>27
           ans=INKEY(0)
        ENDDO
        IF ans=13
           oldrec=RECNO()
           pg=0
           @ 8,22 SAY "Printing ..."
           GO TOP
           SET PRINT ON
           SET CONSOLE OFF
           DO WHILE .not. EOF() .and. INKEY()<>27
              IF PROW()>55
                 EJECT
              ENDIF
              IF PROW()<1
                 pg=pg+1
                 ? ALIAS(),"LIST",SPACE(50),"Page",LTRIM(STR(pg,3,0))
                 ?
                 IF _hdrprt
                    ?
                    FOR i=1 TO ct
                        ?? _hdr[i]+" "
                    NEXT
                    ?
                    FOR i=1 TO ct
                        ?? REPLICATE(IF(_graphics,"","-"),LEN(_hdr[i]))
                        IF i<ct
                           ?? IF(_graphics,""," ")
                        ENDIF
                    NEXT
                 ENDIF
                 ?
              ENDIF
              FOR i=1 TO ct
                  _fld=_disp[i]
                  _opcol=PCOL()
                  ?? &_fld
                  IF _hdrprt
                     DO WHILE PCOL()-_opcol<LEN(_hdr[i])
                        ?? " "
                     ENDDO
                  ENDIF
                  IF i<ct
                     ?? IF(_graphics,""," ")
                  ENDIF
              NEXT
              ?
              SKIP
           ENDDO
           SET PRINT OFF
           SET CONSOLE ON
           EJECT
           IF LASTKEY()=27
              @ 8,22 SAY "Printing ABORTED by operator."
              @ 9,22 SAY "Press any key to return to browse mode."
              INKEY(0)
           ENDIF
           GO oldrec
        ENDIF
     ENDIF
     POPS()
RETURN

PROCEDURE BESEARCH
     PRIVATE i, ct, _array[FCOUNT()], _fld, _pct, oldrec, srchval
     PRIVATE _startpos, _startrow
     PUSHS()
     ct=FCOUNT()
     _startpos=1
     _startrow=1
     FOR i=1 TO ct
         _array[i]=FIELDNAME(i)
     NEXT
     oldrec=RECNO()
     @ 2,20 CLEAR TO 22,78
     @ 2,20 TO 22,78 DOUBLE
     @ 2,22 SAY "SEARCH"
     @ 4,22 SAY "Select search field:"
     ct=EDARRAY(_array,ct,5,50,20,68,"FIELD LIST")
     IF ct>0
        _fld=_array[ct]
        @ 5,50 CLEAR TO 20,68
        @ 4,42 SAY _fld
        @ 6,22 SAY "Enter search value below:"
        _fldlen=LEN(TRANSFORM(&_fld,""))
        * move to a pretend record
        GO BOTTOM
        IF .not. EOF()
           SKIP
        ENDIF
        srchval=&_fld
        IF TYPE(_fld)="C"
           @ 8,22 GET srchval PICTURE "@S50"
        ELSE
           @ 8,22 GET srchval
        ENDIF
        SET CURSOR ON
        READ
        SET CURSOR OFF
        IF LASTKEY()<>27
           IF TYPE("srchval")="C"
              srchval=TRIM(srchval)
           ENDIF
           GO TOP
           IF INDEXKEY(1)=_fld
              SEEK srchval
           ELSE
              LOCATE FOR &_fld = srchval
           ENDIF
           IF .not. FOUND()
              @ 10,30 CLEAR TO 12,50
              @ 10,30 TO 12,50 DOUBLE
              @ 11,32 SAY "VALUE NOT FOUND"
              INKEY(2)
              GO oldrec
           ENDIF
        ELSE
           GO oldrec
        ENDIF
     ENDIF
     POPS()
RETURN

PROCEDURE MARKLN
     markln=ROW()
     @ markln,0 SAY ""
RETURN

PROCEDURE UNMARKLN
     @ markln,0 SAY ""
RETURN

FUNCTION SELFLDS
     PRIVATE _r,_c,_i,_pos,_work,_ct,_dct,_key,_startrow,_startpos,_fldlen,_fld,_colsused,_hdlen

     _startpos=1
     _startrow=1
     _ct=FCOUNT()
     _dct=0
     _dispstr=""
     _colsused=0
     FOR _i=1 TO _ct
         _array[_i]=FIELDNAME(_i)
     NEXT
     DO WHILE _ct>0
        _pos=EDARRAY(_array,_ct,5,50,20,68,"FIELD LIST")
        IF _startpos>_ct
           _startpos=_ct
        ENDIF
        _key=UPPER(CHR(LASTKEY()))
        DO CASE
           CASE _key=CHR(27)
                EXIT
           CASE _key=CHR(13)
                _dct=_dct+1
                AINS(_disp,_dct)
                _disp[_dct]=_array[_pos]
                _fld=_disp[_dct]
                _fldlen = LEN ( TRANSFORM ( &_fld , "" ) )
                _hdlen=0
                IF _hdrprt
                   _hdr[_dct]=ALLTRIM(GETHDR())
                   IF LEN(_hdr[_dct])<_fldlen
                      _hdr[_dct]=_hdr[_dct]+SPACE(_fldlen-LEN(_hdr[_dct]))
                   ENDIF
                   _hdlen=LEN(_hdr[_dct])
                ENDIF
                _colsused=_colsused+IF(_hdlen>_fldlen,_hdlen,_fldlen)+1
                @ 21,36 SAY STR(_colsused,3,0)
                IF _dct>1
                   _dispstr=_dispstr+", "
                ENDIF
                _dispstr=_dispstr+_array[_pos]
                ADEL(_array,_pos)
                _ct=_ct-1
                FOR _i=1 to 14
                    @ 5+_i,22 SAY MEMOLINE(_dispstr,25,_i)
                NEXT
        ENDCASE
     ENDDO
RETURN _dct

FUNCTION GETHDR
     PRIVATE hdr
     hdr=_fld+SPACE(30-LEN(_fld))
     @ 24,0 SAY "Column header: " GET hdr
     READ
     @ 24,0
RETURN hdr

FUNCTION EDARRAY                                                               
PARAMETERS _array, _count, _rowbeg, _colbeg, _rowend, _colend, _message
PRIVATE _pagebeg, _pagesize, _arr, _tmpscrn
* assume defined: _startpos, _startrow

   IF TYPE("_message")<>"C"   && verify parameters have correct type, etc.
      _message=""
   ENDIF
   IF   TYPE("_array")<>"A";
    .or. TYPE("_count")<>"N";
    .or. TYPE("_rowbeg")<>"N";
    .or. TYPE("_colbeg")<>"N";
    .or. TYPE("_rowend")<>"N";
    .or. TYPE("_colend")<>"N"
        RETURN (0)
   ENDIF

   * Save the screen before drawing
   PUSHS()

   * Wide enough for message?  If not, expand.  If so, center.
   IF _colend-_colbeg-1<LEN(_message)
      _colend=_colbeg+LEN(_message)+1
   ELSE
      _message=CENTERIN(_message,_colend-_colbeg-1)
   ENDIF

   * clear and print box and message
   SCROLL (_rowbeg,_colbeg,_rowend,_colend,0)
   @ _rowbeg,_colbeg TO _rowend, _colend DOUBLE
   IF LEN(_message)>0
      @ _rowbeg+1,_colbeg+1 SAY _message
      @ _rowbeg+2,_colbeg+1 TO _rowbeg+2,_colend-1
      _rowbeg=_rowbeg+2
   ENDIF

   * adjust row and column parameters to reflect the smaller window where
   * scrolling will actually occur
   _rowbeg=_rowbeg+1
   _rowend=_rowend-1
   _colbeg=_colbeg+3
   _colend=_colend-2
   _pagesize=_rowend-_rowbeg+1
   _result=ACHOICE(_rowbeg,_colbeg,_rowend,_colend,_array,.t.,"",_startpos,_startrow)
   IF _result<>0
      _startrow=ROW()-_rowbeg+1
      _startpos=_result
   ENDIF
   POPS()
RETURN _result

FUNCTION CENTERIN
PARAMETER _string,_pr_width
   IF _pr_width>LEN(_string)
      RETURN SPACE((_pr_width-LEN(_string))/2)+_string+SPACE(ROUND((_pr_width-LEN(_string))/2,0))
   ENDIF
RETURN _string

FUNCTION QPARSE
     PARAMETERS array,string
     PRIVATE i,pos
     i=0
     pos=0
     DO WHILE LEN(string)>0
        pos=AT(CHR(1),string)
        IF pos=0
           EXIT
        ENDIF
        i=i+1
        array[i]=SUBSTR(string,1,pos-1)
        string=SUBSTR(string,pos+1)
     ENDDO
RETURN i

FUNCTION QBUILD
     PARAMETER array,count
     PRIVATE i,result
     result=""
     FOR i=1 TO count
         result=result+ALLTRIM(array[i])+CHR(1)
     NEXT
     RETURN result

FUNCTION PUSHS
     IF TYPE("_scr")<>"A"
        PUBLIC _scr[20]
     ENDIF
     AINS(_scr,1)
     SAVE SCREEN TO _scr[1]
     PUSHC()
RETURN .t.

FUNCTION POPS
     RESTORE SCREEN FROM _scr[1]
     ADEL(_scr,1)
     POPC()
RETURN .T.

FUNCTION PUSHC
     IF TYPE("_crs")<>"A"
        PUBLIC _crs[20]
        PUBLIC _ccs[20]
     ENDIF
     AINS(_crs,1)
     _crs[1]=ROW()
     AINS(_ccs,1)
     _ccs[1]=COL()
RETURN .T.

FUNCTION POPC
     @ _crs[1],_ccs[1] SAY ""
     ADEL(_crs,1)
     ADEL(_ccs,1)
RETURN .T.
